diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 9e953dda8..858c08536 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -2083,32 +2083,32 @@ public class World implements WorldSource {
                         continue;
                     }
                     flag = true;
-                    block.handleEntityInside(this, k1, l1, i2, entity, vec3d);
+                    block.handleEntityInside(this, k1, l1, i2, entity, vec3);
                 }
 
             }
 
         }
 
-        if(vec3d.lengthVector() > 0.0D && addVelocity)
+        if(vec3.length() > 0.0D && addVelocity)
         {
-            vec3d = vec3d.normalize();
+            vec3 = vec3.normalize();
             double d = 0.014D;
-            entity.xd += vec3d.xCoord * d;
-            entity.yd += vec3d.yCoord * d;
-            entity.zd += vec3d.zCoord * d;
+            entity.xd += vec3.x * d;
+            entity.yd += vec3.y * d;
+            entity.zd += vec3.z * d;
         }
         return flag;
     }
 
     public boolean isMaterialInBB(AABB axisalignedbb, Material ... materials)
     {
-        int minX_i = MathHelper.floor_double(axisalignedbb.minX);
-        int maxX_i = MathHelper.floor_double(axisalignedbb.maxX + 1.0D);
-        int minY_i = MathHelper.floor_double(axisalignedbb.minY);
-        int maxY_i = MathHelper.floor_double(axisalignedbb.maxY + 1.0D);
-        int minZ_i = MathHelper.floor_double(axisalignedbb.minZ);
-        int maxZ_i = MathHelper.floor_double(axisalignedbb.maxZ + 1.0D);
+        int minX_i = MathHelper.floor(axisalignedbb.minX);
+        int maxX_i = MathHelper.floor(axisalignedbb.maxX + 1.0D);
+        int minY_i = MathHelper.floor(axisalignedbb.minY);
+        int maxY_i = MathHelper.floor(axisalignedbb.maxY + 1.0D);
+        int minZ_i = MathHelper.floor(axisalignedbb.minZ);
+        int maxZ_i = MathHelper.floor(axisalignedbb.maxZ + 1.0D);
         for(int _x = minX_i; _x < maxX_i; _x++)
         {
             for(int _y = minY_i; _y < maxY_i; _y++)
@@ -2127,8 +2127,8 @@ public class World implements WorldSource {
                         if (!isMaterial) continue;
 
                         block.setBlockBoundsBasedOnState(this, _x, _y, _z);
-                        if (axisalignedbb.intersectsWith(
-                            AABB.getBoundingBoxFromPool(_x + block.minZ, _y + block.minY, _z + block.minZ,
+                        if (axisalignedbb.intersects(
+                            AABB.getTemporaryBB(_x + block.minZ, _y + block.minY, _z + block.minZ,
                                 _x + block.maxZ, _y + block.maxY, _z + block.maxZ))){
                             return true;
                         }
@@ -2143,12 +2143,12 @@ public class World implements WorldSource {
 
     public boolean isAABBInMaterial(AABB axisalignedbb, Material material)
     {
-        int i = MathHelper.floor_double(axisalignedbb.minX);
-        int j = MathHelper.floor_double(axisalignedbb.maxX + 1.0D);
-        int k = MathHelper.floor_double(axisalignedbb.minY);
-        int l = MathHelper.floor_double(axisalignedbb.maxY + 1.0D);
-        int i1 = MathHelper.floor_double(axisalignedbb.minZ);
-        int j1 = MathHelper.floor_double(axisalignedbb.maxZ + 1.0D);
+        int i = MathHelper.floor(axisalignedbb.minX);
+        int j = MathHelper.floor(axisalignedbb.maxX + 1.0D);
+        int k = MathHelper.floor(axisalignedbb.minY);
+        int l = MathHelper.floor(axisalignedbb.maxY + 1.0D);
+        int i1 = MathHelper.floor(axisalignedbb.minZ);
+        int j1 = MathHelper.floor(axisalignedbb.maxZ + 1.0D);
         for(int k1 = i; k1 < j; k1++)
         {
             for(int l1 = k; l1 < l; l1++)
@@ -2193,16 +2193,16 @@ public class World implements WorldSource {
         else
             explosion = new ExplosionCannonball(this, entity, x, y, z, explosionSize);
         explosion.isFlaming = flaming;
-        explosion.doExplosionA();
-        explosion.doExplosionB(true);
+        explosion.explode();
+        explosion.addEffects(true);
         return explosion;
     }
 
-    public float func_675_a(Vec3d vec3d, AABB axisalignedbb)
+    public float getSeenPercent(Vec3 vec3, AABB aabb)
     {
-        double d = 1.0D / ((axisalignedbb.maxX - axisalignedbb.minX) * 2D + 1.0D);
-        double d1 = 1.0D / ((axisalignedbb.maxY - axisalignedbb.minY) * 2D + 1.0D);
-        double d2 = 1.0D / ((axisalignedbb.maxZ - axisalignedbb.minZ) * 2D + 1.0D);
+        double d = 1.0D / ((aabb.maxX - aabb.minX) * 2D + 1.0D);
+        double d1 = 1.0D / ((aabb.maxY - aabb.minY) * 2D + 1.0D);
+        double d2 = 1.0D / ((aabb.maxZ - aabb.minZ) * 2D + 1.0D);
         int i = 0;
         int j = 0;
         for(float f = 0.0F; f <= 1.0F; f = (float)((double)f + d))
@@ -2211,10 +2211,10 @@ public class World implements WorldSource {
             {
                 for(float f2 = 0.0F; f2 <= 1.0F; f2 = (float)((double)f2 + d2))
                 {
-                    double d3 = axisalignedbb.minX + (axisalignedbb.maxX - axisalignedbb.minX) * (double)f;
-                    double d4 = axisalignedbb.minY + (axisalignedbb.maxY - axisalignedbb.minY) * (double)f1;
-                    double d5 = axisalignedbb.minZ + (axisalignedbb.maxZ - axisalignedbb.minZ) * (double)f2;
-                    if(checkBlockCollisionBetweenPoints(Vec3d.createVector(d3, d4, d5), vec3d) == null)
+                    double d3 = aabb.minX + (aabb.maxX - aabb.minX) * (double)f;
+                    double d4 = aabb.minY + (aabb.maxY - aabb.minY) * (double)f1;
+                    double d5 = aabb.minZ + (aabb.maxZ - aabb.minZ) * (double)f2;
+                    if(checkBlockCollisionBetweenPoints(Vec3.getTempVec3(d3, d4, d5), vec3) == null)
                     {
                         i++;
                     }
@@ -2228,19 +2228,19 @@ public class World implements WorldSource {
         return (float)i / (float)j;
     }
 
-    public void onBlockHit(EntityPlayer entityplayer, int x, int y, int z, Side side)
+    public void onBlockHit(Player entityplayer, int x, int y, int z, Side side)
     {
         x += side.getOffsetX();
         y += side.getOffsetY();
         z += side.getOffsetZ();
-        if(getBlockId(x, y, z) == Block.fire.id)
+        if(getBlockId(x, y, z) == Blocks.FIRE.id)
         {
             playSoundEffect(entityplayer, 1004, x, y, z, 0);
             setBlockWithNotify(x, y, z, 0);
         }
     }
 
-    public Entity func_4085_a(Class class1)
+    public Entity findSubclassOf(Class<? extends Entity> clazz) // this is what the b1.2 mappings called this
     {
         return null;
     }
@@ -2256,19 +2256,19 @@ public class World implements WorldSource {
     }
 
     @Override
-    public TileEntity getBlockTileEntity(int x, int y, int z)
+    public BlockEntity getBlockEntity(int x, int y, int z)
     {
         Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
         if(chunk != null)
         {
-            return chunk.getTileEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
+            return chunk.getBlockEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
         } else
         {
             return null;
         }
     }
 
-    public void setBlockTileEntity(int i, int j, int k, TileEntity tileentity)
+    public void setBlockTileEntity(int i, int j, int k, BlockEntity tileentity)
     {
         if(!tileentity.isInvalid())
         {
@@ -2280,11 +2280,11 @@ public class World implements WorldSource {
                 field_30900_E.add(tileentity);
             } else
             {
-                loadedTileEntityList.add(tileentity);
+                loadedBlockEntityList.add(tileentity);
                 Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(i, Chunk.CHUNK_SIZE_X), Math.floorDiv(k, Chunk.CHUNK_SIZE_Z));
                 if(chunk != null)
                 {
-                    chunk.setTileEntity(i & (Chunk.CHUNK_SIZE_X - 1), j, k & (Chunk.CHUNK_SIZE_Z - 1), tileentity);
+                    chunk.setBlockEntity(i & (Chunk.CHUNK_SIZE_X - 1), j, k & (Chunk.CHUNK_SIZE_Z - 1), tileentity);
                 }
             }
         }
@@ -2292,7 +2292,7 @@ public class World implements WorldSource {
 
     public void removeBlockTileEntity(int i, int j, int k)
     {
-        TileEntity tileentity = getBlockTileEntity(i, j, k);
+        BlockEntity tileentity = getBlockEntity(i, j, k);
 
         if(tileentity != null && field_31055_L)
         {
@@ -2301,12 +2301,12 @@ public class World implements WorldSource {
         {
             if(tileentity != null)
             {
-                loadedTileEntityList.remove(tileentity);
+                loadedBlockEntityList.remove(tileentity);
             }
             Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(i, Chunk.CHUNK_SIZE_X), Math.floorDiv(k, Chunk.CHUNK_SIZE_Z));
             if(chunk != null)
             {
-                chunk.removeTileEntity(i & (Chunk.CHUNK_SIZE_X - 1), j, k & (Chunk.CHUNK_SIZE_Z - 1));
+                chunk.removeBlockEntity(i & (Chunk.CHUNK_SIZE_X - 1), j, k & (Chunk.CHUNK_SIZE_Z - 1));
             }
         }
     }
@@ -2551,9 +2551,9 @@ public class World implements WorldSource {
         positionsToUpdate.clear();
         for(int i = 0; i < players.size(); i++)
         {
-            EntityPlayer entityplayer = players.get(i);
-            int playerChunkX = MathHelper.floor_double(entityplayer.x / Chunk.CHUNK_SIZE_X);
-            int playerChunkZ = MathHelper.floor_double(entityplayer.z / Chunk.CHUNK_SIZE_Z);
+            Player entityplayer = players.get(i);
+            int playerChunkX = MathHelper.floor(entityplayer.x / Chunk.CHUNK_SIZE_X);
+            int playerChunkZ = MathHelper.floor(entityplayer.z / Chunk.CHUNK_SIZE_Z);
             byte radius = 9;
             for(int x = -radius; x <= radius; x++)
             {
@@ -2581,12 +2581,12 @@ public class World implements WorldSource {
             int blockZ = (randVal / (Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (Chunk.CHUNK_SIZE_Z - 1);
 
             if (caveSoundCounter == 0) {
-                int blockY = (randVal / (heightBlocks * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (heightBlocks - 1);
+                int blockY = (randVal / (HEIGHT_BLOCKS * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (HEIGHT_BLOCKS - 1);
                 int id = chunk.getBlockID(blockX, blockY, blockZ);
                 blockX += chunkBlockX;
                 blockZ += chunkBlockZ;
                 if (id == 0 && getFullBlockLightValue(blockX, blockY, blockZ) <= rand.nextInt(8) && getSavedLightValue(LightLayer.Sky, blockX, blockY, blockZ) <= 0) {
-                    EntityPlayer entityplayer1 = getClosestPlayer((double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, 8D);
+                    Player entityplayer1 = getClosestPlayer((double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, 8D);
                     if (entityplayer1 != null && entityplayer1.distanceToSqr((double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D) > 4D) {
                         playSoundEffect(null, SoundCategory.CAVE_SOUNDS, (double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, "ambient.cave.cave", 0.7F, 0.8F + rand.nextFloat() * 0.2F);
                         caveSoundCounter = rand.nextInt(12000) + 6000;
@@ -2607,7 +2607,7 @@ public class World implements WorldSource {
                 int iRandVal = updateLCG >> 2;
                 int iBlockX = iRandVal & (Chunk.CHUNK_SIZE_X - 1);
                 int iBlockZ = (iRandVal / (Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (Chunk.CHUNK_SIZE_Z - 1);
-                int iBlockY = (iRandVal / (heightBlocks * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (heightBlocks - 1);
+                int iBlockY = (iRandVal / (HEIGHT_BLOCKS * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (HEIGHT_BLOCKS - 1);
                 int id = chunk.getBlockID(iBlockX, iBlockY, iBlockZ);
                 if (Block.shouldTick[id]) {
                     Block.blocksList[id].updateTick(this, iBlockX + chunkBlockX, iBlockY, iBlockZ + chunkBlockZ, rand);
@@ -2665,7 +2665,7 @@ public class World implements WorldSource {
             int id = getBlockId(rx, ry, rz);
             if(id > 0)
             {
-                Block.blocksList[id].randomDisplayTick(this, rx, ry, rz, random);
+                Block.blocksList[id].animationTick(this, rx, ry, rz, random);
             }
         }
 
@@ -2674,10 +2674,10 @@ public class World implements WorldSource {
     public List<Entity> getEntitiesWithinAABBExcludingEntity(Entity entity, AABB aabb)
     {
         entityBuffer.clear();
-        int minX = MathHelper.floor_double((aabb.minX - 2D) / Chunk.CHUNK_SIZE_X);
-        int maxX = MathHelper.floor_double((aabb.maxX + 2D) / Chunk.CHUNK_SIZE_X);
-        int minZ = MathHelper.floor_double((aabb.minZ - 2D) / Chunk.CHUNK_SIZE_Z);
-        int maxZ = MathHelper.floor_double((aabb.maxZ + 2D) / Chunk.CHUNK_SIZE_Z);
+        int minX = MathHelper.floor((aabb.minX - 2D) / Chunk.CHUNK_SIZE_X);
+        int maxX = MathHelper.floor((aabb.maxX + 2D) / Chunk.CHUNK_SIZE_X);
+        int minZ = MathHelper.floor((aabb.minZ - 2D) / Chunk.CHUNK_SIZE_Z);
+        int maxZ = MathHelper.floor((aabb.maxZ + 2D) / Chunk.CHUNK_SIZE_Z);
         for(int x = minX; x <= maxX; x++)
         {
             for(int z = minZ; z <= maxZ; z++)
@@ -2694,10 +2694,10 @@ public class World implements WorldSource {
 
     public List<Entity> getEntitiesWithinAABB(Class<? extends Entity> ofClass, AABB aabb)
     {
-        int minX = MathHelper.floor_double((aabb.minX - 2D) / Chunk.CHUNK_SIZE_X);
-        int maxX = MathHelper.floor_double((aabb.maxX + 2D) / Chunk.CHUNK_SIZE_X);
-        int minZ = MathHelper.floor_double((aabb.minZ - 2D) / Chunk.CHUNK_SIZE_Z);
-        int maxZ = MathHelper.floor_double((aabb.maxZ + 2D) / Chunk.CHUNK_SIZE_Z);
+        int minX = MathHelper.floor((aabb.minX - 2D) / Chunk.CHUNK_SIZE_X);
+        int maxX = MathHelper.floor((aabb.maxX + 2D) / Chunk.CHUNK_SIZE_X);
+        int minZ = MathHelper.floor((aabb.minZ - 2D) / Chunk.CHUNK_SIZE_Z);
+        int maxZ = MathHelper.floor((aabb.maxZ + 2D) / Chunk.CHUNK_SIZE_Z);
         List<Entity> entities = new ArrayList<>();
         for(int x = minX; x <= maxX; x++)
         {
@@ -2719,7 +2719,7 @@ public class World implements WorldSource {
         return loadedEntityList;
     }
 
-    public void updateTileEntityChunkAndSendToPlayer(int x, int y, int z, TileEntity tileEntity)
+    public void updateTileEntityChunkAndSendToPlayer(int x, int y, int z, BlockEntity blockEntity)
     {
         if(isBlockLoaded(x, y, z))
         {
@@ -2727,7 +2727,7 @@ public class World implements WorldSource {
         }
         for(int l = 0; l < listeners.size(); l++)
         {
-            listeners.get(l).tileEntityChanged(x, y, z, tileEntity);
+            listeners.get(l).tileEntityChanged(x, y, z, blockEntity);
         }
     }
 
@@ -2784,14 +2784,14 @@ public class World implements WorldSource {
         {
             block = null;
         }
-        return blockId > 0 && block == null && block1.canPlaceBlockOnSide(this, x, y, z, side.getId());
+        return blockId > 0 && block == null && block1.canPlaceBlockOnSide(this, x, y, z, side);
     }
 
     public Path getPathToEntity(Entity entity, Entity entityToTravelTo, float distance)
     {
-        int x1 = MathHelper.floor_double(entity.x);
-        int y2 = MathHelper.floor_double(entity.y);
-        int z1 = MathHelper.floor_double(entity.z);
+        int x1 = MathHelper.floor(entity.x);
+        int y2 = MathHelper.floor(entity.y);
+        int z1 = MathHelper.floor(entity.z);
         int radius = (int)(distance + 16F);
         int xMin = x1 - radius;
         int yMin = y2 - radius;
@@ -2805,9 +2805,9 @@ public class World implements WorldSource {
 
     public Path getEntityPathToXYZ(Entity entity, int i, int j, int k, float f)
     {
-        int l = MathHelper.floor_double(entity.x);
-        int i1 = MathHelper.floor_double(entity.y);
-        int j1 = MathHelper.floor_double(entity.z);
+        int l = MathHelper.floor(entity.x);
+        int i1 = MathHelper.floor(entity.y);
+        int j1 = MathHelper.floor(entity.z);
         int k1 = (int)(f + 8F);
         int l1 = l - k1;
         int i2 = i1 - k1;
@@ -2819,85 +2819,53 @@ public class World implements WorldSource {
         return (new PathFinder(chunkcache)).findPath(entity, i, j, k, f);
     }
 
-    public boolean isBlockProvidingPowerTo(int i, int j, int k, int l)
-    {
-        int i1 = getBlockId(i, j, k);
-        if(i1 == 0)
-        {
-            return false;
-        } else
-        {
-            return Block.blocksList[i1].isIndirectlyPoweringTo(this, i, j, k, l);
-        }
+    public boolean isBlockProvidingPowerTo(int x, int y, int z, Side side) {
+        Block block = getBlock(x, y, z);
+        if (block == null) return false;
+        return block.getDirectSignal(this, x, y, z, side);
     }
 
-    public boolean isBlockGettingPowered(int i, int j, int k)
-    {
-        if(isBlockProvidingPowerTo(i, j - 1, k, 0))
-        {
-            return true;
-        }
-        if(isBlockProvidingPowerTo(i, j + 1, k, 1))
-        {
-            return true;
-        }
-        if(isBlockProvidingPowerTo(i, j, k - 1, 2))
-        {
-            return true;
-        }
-        if(isBlockProvidingPowerTo(i, j, k + 1, 3))
-        {
-            return true;
-        }
-        if(isBlockProvidingPowerTo(i - 1, j, k, 4))
-        {
-            return true;
+    public boolean isBlockGettingPowered(int x, int y, int z) {
+        for (Side side : Side.sides){
+            if (isBlockProvidingPowerTo(
+                x + side.getOffsetX(),
+                y + side.getOffsetY(),
+                z + side.getOffsetZ(),
+                side))
+            {
+                return true;
+            }
         }
-        return isBlockProvidingPowerTo(i + 1, j, k, 5);
+        return false;
     }
 
-    public boolean isBlockIndirectlyProvidingPowerTo(int i, int j, int k, int l)
-    {
-        int i1 = getBlockId(i, j, k);
-        if(isBlockNormalCube(i, j, k) && i1 != Block.blockRedstone.id)
-        {
-            return isBlockGettingPowered(i, j, k);
+    public boolean isBlockIndirectlyProvidingPowerTo(int x, int y, int z, Side side) {
+        Block block = getBlock(x, y, z);
+        if(isBlockNormalCube(x, y, z) && block != Blocks.BLOCK_REDSTONE && block != Blocks.PUMPKIN_REDSTONE) {
+            return isBlockGettingPowered(x, y, z);
         }
-        if(i1 == 0)
-        {
+        if(block == null) {
             return false;
-        } else
-        {
-            return Block.blocksList[i1].isPoweringTo(this, i, j, k, l);
         }
+
+        return block.getSignal(this, x, y, z, side);
     }
 
-    public boolean isBlockIndirectlyGettingPowered(int i, int j, int k)
-    {
-        if(isBlockIndirectlyProvidingPowerTo(i, j - 1, k, 0))
-        {
-            return true;
-        }
-        if(isBlockIndirectlyProvidingPowerTo(i, j + 1, k, 1))
-        {
-            return true;
-        }
-        if(isBlockIndirectlyProvidingPowerTo(i, j, k - 1, 2))
-        {
-            return true;
-        }
-        if(isBlockIndirectlyProvidingPowerTo(i, j, k + 1, 3))
-        {
-            return true;
-        }
-        if(isBlockIndirectlyProvidingPowerTo(i - 1, j, k, 4))
-        {
-            return true;
+    public boolean isBlockIndirectlyGettingPowered(int x, int y, int z) {
+        for (Side side : Side.sides){
+            if (isBlockIndirectlyProvidingPowerTo(
+                x + side.getOffsetX(),
+                y + side.getOffsetY(),
+                z + side.getOffsetZ(),
+                side))
+            {
+                return true;
+            }
         }
-        return isBlockIndirectlyProvidingPowerTo(i + 1, j, k, 5);
+        return false;
     }
 
-    public EntityPlayer getClosestPlayerToEntity(Entity entity, double radius)
+    public Player getClosestPlayerToEntity(Entity entity, double radius)
     {
         return getClosestPlayer(entity.x, entity.y, entity.z, radius);
     }
@@ -2905,13 +2873,13 @@ public class World implements WorldSource {
     /**
      * @param radius Radius around the point to search for a player, a radius less than 0 denotes searching for the closest player with 0 regard for radius
      */
-    public EntityPlayer getClosestPlayer(double x, double y, double z, double radius)
+    public Player getClosestPlayer(double x, double y, double z, double radius)
     {
         double closestDistance = Double.POSITIVE_INFINITY;
-        EntityPlayer entityplayer = null;
+        Player entityplayer = null;
         if (radius < 0) {
 
-            for (EntityPlayer entityPlayer1 : players) {
+            for (Player entityPlayer1 : players) {
                 double currentDistance = entityPlayer1.distanceToSqr(x, y, z);
                 if ((currentDistance < closestDistance)) {
                     closestDistance = currentDistance;
@@ -2920,7 +2888,7 @@ public class World implements WorldSource {
             }
         } else {
             double rSquared = radius * radius;
-            for (EntityPlayer entityPlayer1 : players) {
+            for (Player entityPlayer1 : players) {
                 double currentDistance = entityPlayer1.distanceToSqr(x, y, z);
                 if (currentDistance < rSquared && (currentDistance < closestDistance)) {
                     closestDistance = currentDistance;
@@ -2933,9 +2901,9 @@ public class World implements WorldSource {
 
 
 
-    public EntityPlayer getPlayerEntityByName(String s)
+    public Player getPlayerEntityByName(String s)
     {
-        for (EntityPlayer player : players) {
+        for (Player player : players) {
             if (s.equals(player.username)) {
                 return player;
             }
@@ -3091,8 +3059,8 @@ public class World implements WorldSource {
 
     public void joinEntityInSurroundings(Entity entity)
     {
-        int i = MathHelper.floor_double(entity.x / Chunk.CHUNK_SIZE_X);
-        int j = MathHelper.floor_double(entity.z / Chunk.CHUNK_SIZE_Z);
+        int i = MathHelper.floor(entity.x / Chunk.CHUNK_SIZE_X);
+        int j = MathHelper.floor(entity.z / Chunk.CHUNK_SIZE_Z);
         byte byte0 = 2;
         for(int k = i - byte0; k <= i + byte0; k++)
         {
@@ -3109,7 +3077,7 @@ public class World implements WorldSource {
         }
     }
 
-    public boolean canMineBlock(EntityPlayer entityplayer, int i, int j, int k)
+    public boolean canMineBlock(Player entityplayer, int i, int j, int k)
     {
         return true;
     }
@@ -3198,13 +3166,13 @@ public class World implements WorldSource {
         return levelData;
     }
 
-    public void updateEnoughPlayersSleepingFlag(EntityPlayer player)
+    public void updateEnoughPlayersSleepingFlag(Player player)
     {
         enoughPlayersSleeping = false;
         if(players.size() > 0) {
             int playersSleeping = 0;
             int req = getPlayersRequiredToSkipNight();
-            for(EntityPlayer p : players)
+            for(Player p : players)
                 if(p.isPlayerSleeping()) playersSleeping++;
             if(playersSleeping >= req) {
                 enoughPlayersSleeping = true;
@@ -3227,7 +3195,7 @@ public class World implements WorldSource {
             {
                 break;
             }
-            EntityPlayer entityplayer = (EntityPlayer)iterator.next();
+            Player entityplayer = (Player)iterator.next();
             if(entityplayer.isPlayerSleeping())
             {
                 entityplayer.wakeUpPlayer(false, false);
@@ -3244,7 +3212,7 @@ public class World implements WorldSource {
         if(enoughPlayersSleeping && !isClientSide)
         {
             int fullyAsleep = 0;
-            for(EntityPlayer player : players) if(player.isPlayerFullyAsleep()) fullyAsleep++;
+            for(Player player : players) if(player.isPlayerFullyAsleep()) fullyAsleep++;
             return fullyAsleep >= getPlayersRequiredToSkipNight() && fullyAsleep > 0;
         } else {
             return false;
@@ -3297,7 +3265,7 @@ public class World implements WorldSource {
         playSoundEffect(null, id, x, y, z, data);
     }
 
-    public void playSoundEffect(EntityPlayer entityplayer, int id, int x, int y, int z, int data)
+    public void playSoundEffect(Player entityplayer, int id, int x, int y, int z, int data)
     {
         for (LevelListener listener : listeners) {
             listener.levelEvent(entityplayer, id, x, y, z, data);
@@ -3310,18 +3278,18 @@ public class World implements WorldSource {
         return worldType;
     }
 
-    public EntityItem dropItem(int x, int y, int z, ItemStack itemStack) {
+    public ItemEntity dropItem(int x, int y, int z, ItemStack itemStack) {
         float f = 0.7F;
         double x1 = (double) (rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
         double y1 = (double) (rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
         double z1 = (double) (rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-        EntityItem entityitem = new EntityItem(this, (double) x + x1, (double) y + y1, (double) z + z1, itemStack);
-        entityitem.delayBeforeCanPickup = 10;
+        ItemEntity entityitem = new ItemEntity(this, (double) x + x1, (double) y + y1, (double) z + z1, itemStack);
+        entityitem.pickupDelay = 10;
         entityJoinedWorld(entityitem);
         return entityitem;
     }
     public void sendGlobalMessage(String message){
-        for (EntityPlayer player: players){
+        for (Player player: players){
             player.sendMessage(message);
         }
     }
diff --git a/src/main/java/net/minecraft/core/world/WorldSource.java b/src/main/java/net/minecraft/core/world/WorldSource.java
index e5843d29c..4fb084f77 100644
--- a/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
@@ -14,7 +14,7 @@ public interface WorldSource
 
     Block getBlock(int x, int y, int z);
 
-    TileEntity getBlockTileEntity(int x, int y, int z);
+    BlockEntity getBlockEntity(int x, int y, int z);
 
     float getBrightness(int x, int y, int z, int blockLightValue);
     
